/**
 *  \file IMP/container/ListSingletonContainer.h
 *  \brief Store a list of ParticlesTemp
 *
 *  WARNING This file was generated from ListSingletonContainer.h
 *  in /builddir/build/BUILD/imp-2.1.1/imp/tools/build/container_templates/container
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2013 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_LIST_SINGLETON_CONTAINER_H
#define IMPCONTAINER_LIST_SINGLETON_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/InternalListSingletonContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a ParticleIndexes
/** \note The order may change when particles are inserted
    as the list is maintained in sorted order.

    \note Changing the contents of the container is a fairly heavy
    weight operation as it resets part of the dependency graph. Use
    a DynamicListSingletonContainer if you want to change the contents
    frequently (eg via a kernel::ScoreState).
 */
class IMPCONTAINEREXPORT ListSingletonContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public SingletonContainer
#else
    public IMP::kernel::internal::InternalListSingletonContainer
#endif
    {
  typedef IMP::kernel::internal::InternalListSingletonContainer P;

 public:
  ListSingletonContainer(kernel::Model *m, const ParticleIndexes &contents,
                         std::string name = "ListSingletonContainer%1%");

  ListSingletonContainer(const ParticlesTemp &ps,
                         std::string name = "ListSingletonContainer%1%");

  void set_particles(const ParticlesTemp &ps);
  void set_particles(const ParticleIndexes &contents);
#ifndef IMP_DOXYGEN
  ListSingletonContainer(kernel::Model *m,
                         std::string name = "ListSingletonContainer %1%");
  ListSingletonContainer(kernel::Model *m, const char *name);

  void add_particle(Particle* vt);
  void add_particles(const ParticlesTemp &c);
  void clear_particles();
#endif
#ifdef SWIG
  ParticleIndexes get_indexes() const;
  ParticleIndexes get_range_indexes() const;
  void do_before_evaluate();
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const SingletonModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(ListSingletonContainer);
};

IMP_OBJECTS(ListSingletonContainer, ListSingletonContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_LIST_SINGLETON_CONTAINER_H */
